#!/usr/bin/python
# -*- coding: utf-8 -*-

#Clases relacionadas con los widgets de opciones

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from qt import *
from Driza.clasesbase import ElementoWidgetOperacion

class ContenedorElementoWidgetGraficos:
	"""Contiene las funciones de adición de widgets necesaria para los contenedores"""
	def parse(self,diccionario):
		"""Transforma un diccionario con el nombre y las opciones de un widget en el propio widget"""
		if diccionario["tipo"]=="Texto":
			self.addT(diccionario["nombre"],diccionario["texto"])
		elif diccionario["tipo"]=="Variables":
			self.addV(diccionario["nombre"])
		


	def addT(self,nombre,args):
		widget=EWGTexto(self,nombre,args)
		self.lista.append(widget)

	def addV(self,nombre):
		widget=EWGListaVariables(self,nombre,self.dato)
		self.lista.append(widget)

	def opciones(self):
		"""Devuelve un diccionario con las opciones y sus valores [Virtual]"""
		diccionario={}
		for elemento in self.lista:
			diccionario.update(elemento.opciones())
		return diccionario

class WGraficos(QVBox,ElementoWidgetOperacion,ContenedorElementoWidgetGraficos):
	"""Cualquier widget que tenga un conjunto de opciones"""
	def __init__(self,dato):
		QVBox.__init__(self,None,"Widget opciones")
		self.lista=[]
		self.dato=dato
		self.clearWState(Qt.WState_Polished)
		self.setCaption("WidgetOpciones")


class ElementoWidgetGraficos:
	"""Clase padre de cualquier elemento que pertenezca a WGraficos"""
	def __init__(self):
		self.diccionario={}

	def opciones(self):
		return {}

class EWGTexto(ElementoWidgetGraficos,QHGroupBox):
	"""Indica que la información sobre ese eje es solamente un texto"""
	def __init__(self,parent,nombre,texto):
		ElementoWidgetGraficos.__init__(self)
		QHGroupBox.__init__(self,parent,"Texto")
		self.setTitle(nombre)
		self.label=QLabel(texto,self)

class EWGListaVariables(ElementoWidgetGraficos,QHGroupBox):
	"""Este eje esta representando a una variable"""
	def __init__(self,parent,nombre,datos):
		ElementoWidgetGraficos.__init__(self)
		QHGroupBox.__init__(self,parent,"Texto")
		self.setTitle(nombre)
		self.nombre=nombre
		from Driza.widgets.widgetsqt import ComboBoxVars
		self.variables=ComboBoxVars(self,datos)

	def opciones(self):
		return {self.nombre:self.variables.currentText().latin1()}
